<?php

namespace Planaday\Config\OptionGroups\General\Debug;

use Planaday\Platform\PlatformAbstraction\LocalizationController;
use Planaday\Utility\DataFilters\InvalidFieldsException;
use Planaday\Utility\DataFilters\TypeValidator;
use Planaday\Utility\Debug\Log\Logging;

class DebugOptionsValidator  {
	use Logging;

	/** @var TypeValidator */
	protected $typeValidator;

	/** @var LocalizationController */
	protected $translator;

	public function __construct( TypeValidator $typeValidator, LocalizationController $translator) {
		$this->typeValidator            = $typeValidator;
		$this->translator               = $translator;
	}

	/**
	 * @param array $data
	 * @param array|null $output if valid, clean data is returned here. if not, errors will be returned here
	 *
	 * @return bool true if valid, false if not
	 */
	public function validate( array $data, ?array &$output ): bool {
		$errors = [];
		$tr     = $this->translator;

		try {
			$data = $this->getSafeData( $data );
		} catch ( InvalidFieldsException $e ) {
			foreach ( $e->getInvalidFields() as $field => $fieldException ) {
				$errors[ $field ] = $tr->translate(
					'Het ' . strtolower( $field ) . ' veld bij de debug opties is met ongeldige data ingevuld.'
				);
			}

			$output = $errors;

			return false;
		}

		$output = $data;
		return true;
	}

	/**
	 * @param array $data
	 *
	 * @return array
	 * @throws InvalidFieldsException
	 */
	private function getSafeData( array $data ): array {
		$tv = $this->typeValidator;

		$bool = [
			DebugOptionsEnum::SEND_DEBUG_LOGS,
			DebugOptionsEnum::ENABLE_FONT_AWESOME
		];

		return $tv->getSafeData( $data, [], [], $bool );
	}
}